aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--.travis.yml2
-rw-r--r--README.md24
-rwxr-xr-xfunctions/utilities.zsh4
-rwxr-xr-xpowerlevel9k.zsh-theme37
-rwxr-xr-xtest/segments/status.spec85
5 files changed, 135 insertions, 17 deletions
diff --git a/.travis.yml b/.travis.yml
index ac94f261..7c526e54 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -74,4 +74,4 @@ before_script:
- "zsh --version"
script:
- - test/suite.spec \ No newline at end of file
+ - test/suite.spec
diff --git a/README.md b/README.md
index 90680ac8..9989d9cc 100644
--- a/README.md
+++ b/README.md
@@ -357,6 +357,17 @@ end of the hostname.
|`POWERLEVEL9K_ALWAYS_SHOW_USER`|false|Always show the username, but conditionalize the hostname.|
|`POWERLEVEL9K_CONTEXT_TEMPLATE`|%n@%m|Default context prompt (username@machine). Refer to the [ZSH Documentation](http://zsh.sourceforge.net/Doc/Release/Prompt-Expansion.html) for all possible expansions, including deeper host depths.|
+This segment can have different states. They might help you to visualize your
+different privileges. Read more about styling with states [here](https://github.com/bhilburn/powerlevel9k/wiki/Stylizing-Your-Prompt#special-segment-colors).
+
+| State | Meaning |
+|---------------|----------------------------------------------------------|
+| `DEFAULT` | You are a normal user |
+| `ROOT` | You are the root user |
+| `SUDO` | You are using elevated rights |
+| `REMOTE_SUDO` | You are SSH'ed into the machine and have elevated rights |
+| `REMOTE` | You are SSH'ed into the machine |
+
##### date
The `date` segment shows the current system date.
@@ -561,6 +572,19 @@ Variable | Default Value | Description |
|----------|---------------|-------------|
|`POWERLEVEL9K_RBENV_PROMPT_ALWAYS_SHOW`|`false`|Set to true if you wish to show the rbenv segment even if the current Ruby version is the same as the global Ruby version|
+##### pyenv
+
+This segment shows the version of Python being used when using `pyenv` to change your current Python stack.
+
+The `PYENV_VERSION` environment variable will be used if specified. Otherwise it figures out the version being used by taking the output of the `pyenv version-name` command.
+
+* If `pyenv` is not in $PATH, nothing will be shown.
+* If the current Python version is the same as the global Python version, nothing will be shown.
+
+| Variable | Default Value | Description |
+|----------|---------------|-------------|
+|`POWERLEVEL9K_PYENV_PROMPT_ALWAYS_SHOW`|`false`|Set to true if you wish to show the pyenv segment even if the current Python version is the same as the global Python version|
+
##### rspec_stats
See [Unit Test Ratios](#unit-test-ratios), below.
diff --git a/functions/utilities.zsh b/functions/utilities.zsh
index 69fd2ec8..127007fb 100755
--- a/functions/utilities.zsh
+++ b/functions/utilities.zsh
@@ -9,9 +9,7 @@
# Exits with 0 if a variable has been previously defined (even if empty)
# Takes the name of a variable that should be checked.
function defined() {
- local varname="$1"
-
- typeset -p "$varname" > /dev/null 2>&1
+ [[ ! -z "${(tP)1}" ]]
}
# Given the name of a variable and a default value, sets the variable
diff --git a/powerlevel9k.zsh-theme b/powerlevel9k.zsh-theme
index ee744799..25e43074 100755
--- a/powerlevel9k.zsh-theme
+++ b/powerlevel9k.zsh-theme
@@ -499,7 +499,7 @@ prompt_battery() {
fi
fi
# return if POWERLEVEL9K_BATTERY_HIDE_ABOVE_THRESHOLD is set and the battery percentage is greater or equal
- if [[ -v "POWERLEVEL9K_BATTERY_HIDE_ABOVE_THRESHOLD" && "${bat_percent}" -ge $POWERLEVEL9K_BATTERY_HIDE_ABOVE_THRESHOLD ]]; then
+ if defined POWERLEVEL9K_BATTERY_HIDE_ABOVE_THRESHOLD && [[ "${bat_percent}" -ge $POWERLEVEL9K_BATTERY_HIDE_ABOVE_THRESHOLD ]]; then
return
fi
@@ -1263,21 +1263,19 @@ prompt_ram() {
"$1_prompt_segment" "$0" "$2" "yellow" "$DEFAULT_COLOR" "$(printSizeHumanReadable "$ramfree" $base)" 'RAM_ICON'
}
-
+################################################################
+# Segment to display rbenv information
+# https://github.com/rbenv/rbenv#choosing-the-ruby-version
set_default POWERLEVEL9K_RBENV_PROMPT_ALWAYS_SHOW false
-# rbenv information
prompt_rbenv() {
- if command which rbenv 2>/dev/null >&2; then
+ if [[ -n "$RBENV_VERSION" ]]; then
+ "$1_prompt_segment" "$0" "$2" "red" "$DEFAULT_COLOR" "$RBENV_VERSION" 'RUBY_ICON'
+ elif [ $commands[rbenv] ]; then
local rbenv_version_name="$(rbenv version-name)"
local rbenv_global="$(rbenv global)"
-
- # Don't show anything if the current Ruby is the same as the global Ruby
- # unless `POWERLEVEL9K_RBENV_PROMPT_ALWAYS_SHOW` is set.
- if [[ $rbenv_version_name == $rbenv_global && "$POWERLEVEL9K_RBENV_PROMPT_ALWAYS_SHOW" = false ]]; then
- return
+ if [[ "${rbenv_version_name}" != "${rbenv_global}" || "${POWERLEVEL9K_RBENV_PROMPT_ALWAYS_SHOW}" == "true" ]]; then
+ "$1_prompt_segment" "$0" "$2" "red" "$DEFAULT_COLOR" "$rbenv_version_name" 'RUBY_ICON'
fi
-
- "$1_prompt_segment" "$0" "$2" "red" "$DEFAULT_COLOR" "$rbenv_version_name" 'RUBY_ICON'
fi
}
@@ -1632,11 +1630,18 @@ prompt_virtualenv() {
}
################################################################
-# pyenv: current active python version (with restrictions)
+# Segment to display pyenv information
# https://github.com/pyenv/pyenv#choosing-the-python-version
+set_default POWERLEVEL9K_PYENV_PROMPT_ALWAYS_SHOW false
prompt_pyenv() {
if [[ -n "$PYENV_VERSION" ]]; then
"$1_prompt_segment" "$0" "$2" "blue" "$DEFAULT_COLOR" "$PYENV_VERSION" 'PYTHON_ICON'
+ elif [ $commands[pyenv] ]; then
+ local pyenv_version_name="$(pyenv version-name)"
+ local pyenv_global="$(pyenv version-file-read $(pyenv root)/version)"
+ if [[ "${pyenv_version_name}" != "${pyenv_global}" || "${POWERLEVEL9K_PYENV_PROMPT_ALWAYS_SHOW}" == "true" ]]; then
+ "$1_prompt_segment" "$0" "$2" "blue" "$DEFAULT_COLOR" "$pyenv_version_name" 'PYTHON_ICON'
+ fi
fi
}
@@ -1783,10 +1788,16 @@ powerlevel9k_preexec() {
set_default POWERLEVEL9K_PROMPT_ADD_NEWLINE false
powerlevel9k_prepare_prompts() {
- local RETVAL RPROMPT_PREFIX RPROMPT_SUFFIX
+ # Return values. These need to be global, because
+ # they are used in prompt_status. Also, we need
+ # to get the return value of the last command at
+ # very first in this function. Do not move the
+ # lines down, otherwise the last command is not
+ # what you expected it to be.
RETVAL=$?
RETVALS=( "$pipestatus[@]" )
+ local RPROMPT_SUFFIX RPROMPT_PREFIX
_P9K_COMMAND_DURATION=$((EPOCHREALTIME - _P9K_TIMER_START))
# Reset start time
diff --git a/test/segments/status.spec b/test/segments/status.spec
new file mode 100755
index 00000000..21bd65bb
--- /dev/null
+++ b/test/segments/status.spec
@@ -0,0 +1,85 @@
+#!/usr/bin/env zsh
+#vim:ft=zsh ts=2 sw=2 sts=2 et fenc=utf-8
+
+# Required for shunit2 to run correctly
+setopt shwordsplit
+SHUNIT_PARENT=$0
+
+function setUp() {
+ export TERM="xterm-256color"
+ # Load Powerlevel9k
+ source powerlevel9k.zsh-theme
+
+ ### Test specific
+ # Resets if someone has set these in his/hers env
+ unset POWERLEVEL9K_STATUS_VERBOSE
+ unset POWERLEVEL9K_STATUS_OK_IN_NON_VERBOSE
+}
+
+function testStatusPrintsNothingIfReturnCodeIsZeroAndVerboseIsUnset() {
+ local POWERLEVEL9K_CUSTOM_WORLD='echo world'
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status custom_world)
+ local POWERLEVEL9K_STATUS_VERBOSE=false
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=false
+
+ assertEquals "%K{white} %F{black}world %k%F{white}%f " "$(build_left_prompt)"
+}
+
+function testStatusWorksAsExpectedIfReturnCodeIsZeroAndVerboseIsSet() {
+ local POWERLEVEL9K_STATUS_VERBOSE=true
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=false
+ local POWERLEVEL9K_STATUS_HIDE_SIGNAME=true
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+
+ assertEquals "%K{black} %F{green%}✔%f %k%F{black}%f " "$(build_left_prompt)"
+}
+
+function testStatusInGeneralErrorCase() {
+ local RETVAL=1
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+ local POWERLEVEL9K_STATUS_VERBOSE=true
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=false
+
+ assertEquals "%K{red} %F{yellow1%}↵ %f%F{yellow1}1 %k%F{red}%f " "$(build_left_prompt)"
+}
+
+function testPipestatusInErrorCase() {
+ local -a RETVALS
+ RETVALS=(0 0 1 0)
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+ local POWERLEVEL9K_STATUS_VERBOSE=true
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=true
+
+ assertEquals "%K{red} %F{yellow1%}↵ %f%F{yellow1}0|0|1|0 %k%F{red}%f " "$(build_left_prompt)"
+}
+
+function testStatusCrossWinsOverVerbose() {
+ local RETVAL=1
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=false
+ local POWERLEVEL9K_STATUS_VERBOSE=true
+ local POWERLEVEL9K_STATUS_CROSS=true
+
+ assertEquals "%K{black} %F{red%}✘%f %k%F{black}%f " "$(build_left_prompt)"
+}
+
+function testStatusShowsSignalNameInErrorCase() {
+ local RETVAL=132
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+ local POWERLEVEL9K_STATUS_SHOW_PIPESTATUS=false
+ local POWERLEVEL9K_STATUS_VERBOSE=true
+ local POWERLEVEL9K_STATUS_HIDE_SIGNAME=false
+
+ assertEquals "%K{red} %F{yellow1%}↵ %f%F{yellow1}SIGILL(4) %k%F{red}%f " "$(build_left_prompt)"
+}
+
+function testStatusSegmentIntegrated() {
+ local POWERLEVEL9K_LEFT_PROMPT_ELEMENTS=(status)
+ local POWERLEVEL9K_RIGHT_PROMPT_ELEMENTS=()
+
+ false; powerlevel9k_prepare_prompts
+
+ assertEquals "%f%b%k%K{black} %F{red%}✘%f %k%F{black}%f " "${(e)PROMPT}"
+}
+
+source shunit2/source/2.1/src/shunit2 \ No newline at end of file